
{*******************************************************}
{                                                       }
{       Borland Delphi Run-time Library                 }
{       WDOSX TCP/IP ABI Utilities Unit                 }
{                                                       }
{       for Delphi 4, 5 WDosX DOS-Extender              }
{       Copyright (c) 2000 by Immo Wache                }
{       e-mail: immo.wache@t-online.de                  }
{                                                       }
{*******************************************************}

{
  Version history:
    IWA 11/20/00 Version 1.1
}

unit WDosAbiUtils;

interface

uses
  WDosResStrings, WDosSocketUtils;

const
  InvalidSocket = $FFFF;

type
  TSocket = Word;

  TDriverInfo =packed record
    MyIp: TIpAddr;
    NetMask: TIpAddr;
    Gateway: TIpAddr;
    DnsServer: TIpAddr;
    TimeServer: TIpAddr;
    Mtu: Word;
    DefTtl: Byte;
    DefTos: Byte;
    Unknown: array [0..1] of Byte;
    TcpMss: Word;
    TcpRwin: Word;
    Debug: Word;
    Domain: array[0..254] of Char;
  end;

  TSessionInfo =packed record
    IpLoc: TIpAddr;
    PortLoc: Word;
    IpRem: TIpAddr;
    PortRem: Word;
    IpProt: Byte;
    Active: Byte;
  end;

  TTcpMode = (tmNormal, tmListener);
  TTcpFlag = (tfMuchAsPossible, tfCrLf, tfPush, tfUrgent);
  TTcpFlags = set of TTcpFlag;

  TTcpIpError =(teNoError, teBadCall, teCritical, teNoHandle, teBadHandle,
                teTimeOut, teBadSession, teNotOpen, teDpmiError, teUnknown);

function AbiErrorMessage(AbiResult: Integer): string;

implementation

function AbiErrorMessage(AbiResult: Integer): string;
var
  Err: TTcpIpError;

  const
    ErrStr: array[TTcpIpError] of string =(
        SAbiNoError,    SAbiBadCall,
        SAbiCritical,   SAbiNoHandle,
        SAbiBadHandle,  SAbiTimeOut,
        SAbiBadSession, SAbiNotOpen,
        SAbiDpmiError,  SAbiUnknownError);

begin
  Err :=TTcpIpError(AbiResult);
  if Err >teUnKnown then Err :=teUnknown;
  Result :=ErrStr[Err];
end;

end.
